<?php
/*******************************************************************************
    Wordpress IDX and Contact Manager Plugin
    Copyright (C) 2010 pyHub Limited/Agent Storm

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*******************************************************************************/
?>

<div class="wrap static">
    
    <div id="agentstorm">
        <div id="agentstorm-logoc"><div id="agentstorm-logo"></div></div>
        <div id="agentstorm-tabs">
            <ul>
                <li><a href="#tabs-1">Settings</a></li>
                <li <?php if (!$this->isConfigured()): ?>class="ui-state-disabled"<?php endif; ?>><a href="#tabs-2">Contact Manager</a></li>
                <li <?php if (!$this->isConfigured()): ?>class="ui-state-disabled"<?php endif; ?>><a href="#tabs-3">Displaying IDX Data</a></li>
                <li <?php if (!$this->isConfigured()): ?>class="ui-state-disabled"<?php endif; ?>><a href="#tabs-4">IDX Data Settings</a></li>
                <li <?php if (!$this->isConfigured()): ?>class="ui-state-disabled"<?php endif; ?>><a href="#tabs-5">Agent Details</a></li>
                <li <?php if (!$this->isConfigured()): ?>class="ui-state-disabled"<?php endif; ?>><a href="#tabs-6">Display Fields</a></li>
            </ul>
            <div id="tabs-1" class="ui-tabs-hide">
                <div class="ui-state-highlight ui-corners-msgbox" style="margin-top: 10px; padding: 0 .7em;"> 
                    <p>
                        <span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span><strong>Information</strong><br />
                        In the boxes below enter the required information for connecting to your Agent Storm Account. If you require assistance installing this plugin, visit the <a href="http://www.agentstorm.com/wiki/">Agent Storm Wiki</a>.
                    </p>
                </div>
                <form action="" method="POST">
                    <div class="agentstorm-input">
                        <label>Built in Stylesheet:</label><br />
                        <span class="small">Themes change the colors of the plugin, Choose a theme that fits your site design or select "Custom" to use your own stylesheet.</span><br />
                        <select name="as_usestyle">
                            <option value="1" <?php if (get_option('as_usestyle') == 1): ?>selected="selected"<?php endif; ?>>Green</option>
                            <option value="2" <?php if (get_option('as_usestyle') == 2): ?>selected="selected"<?php endif; ?>>Red</option>
                            <option value="3" <?php if (get_option('as_usestyle') == 3): ?>selected="selected"<?php endif; ?>>Blue</option>
                            <option value="4" <?php if (get_option('as_usestyle') == 4): ?>selected="selected"<?php endif; ?>>Grey</option>
                            <option value="5" <?php if (get_option('as_usestyle') == 5): ?>selected="selected"<?php endif; ?>>Brown</option>
                            <option value="" <?php if (get_option('as_usestyle') == ''): ?>selected="selected"<?php endif; ?>>Custom</option>
                        </select>
                    </div>
                    <div class="agentstorm-input">
                        <label>Hostname:</label><br />
                        <span class="small">This is the Hostname you connect to when logging in to your Agent Storm account. i.e. http://mycompany.agentstorm.com/</span><br />
                        <input type="text" name="as_hostname" class="text" value="<?php echo (get_option('as_hostname')) ? get_option('as_hostname') : 'http://'; ?>" />
                    </div>
                    <div class="agentstorm-input">
                        <label>API Key:</label><br />
                        <span class="small">Your API Key can be found under the Integration section of your Agent Storm homepage.</span><br />
                        <input type="text" name="as_apikey" class="text" value="<?php echo get_option('as_apikey'); ?>" />
                    </div>
                    <div class="agentstorm-input">
                        <input name="as_settings_save" class="button-secondary" value="Save Changes" type="submit" />
                    </div>
                </form>
            </div>
            <div id="tabs-2" class="ui-tabs-hide">
                <div class="ui-state-highlight ui-corners-msgbox" style="margin-top: 10px; padding: 0 .7em;"> 
                    <p>
                        <span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span><strong>Information</strong><br />
                        The Agent Storm Contact/Prospect Manager keeps track of vistors that request more information via property listings displayed via the Agent Storm IDX widget and also from visitors that fill out the Agent Storm Sidebar Widget.
                    </p>
                </div>
                <form action="" method="POST">
                    <div class="agentstorm-input">
                        <label>Email Notification:</label><br />
                        <span class="small">Send you a notification via email when a new prospect is received.</span><br />
                        <input type="checkbox" name="as_contact_emailnotification" class="text" value="1" <?php if (get_option('as_contact_emailnotification') == true): ?>checked="checked"<?php endif; ?> />
                    </div>
                    <div class="agentstorm-input">
                        <label>Contact Source:</label><br />
                        <span class="small">Set the Source that will be logged with new prospects allowing you to track where your leads are coming from.</span><br />
                        <input type="text" name="as_contact_source" class="text" value="<?php echo get_option('as_contact_source'); ?>" />
                    </div>
                    <!--
                    <div class="agentstorm-input">
                        <label>Assign Tags:</label><br />
                        <span class="small">Assign the following tags to new prospects.</span><br />
                        <input type="text" name="as_contact_tag" value="" /><input type="button" tabindex="3" value="Add" class="button tagadd">
                        <div class="tagchecklist">
                            <span><a class="ntdelbutton" id="post_tag-check-num-0">X</a>&nbsp;Demo</span>
                            <span><a class="ntdelbutton" id="post_tag-check-num-1">X</a>&nbsp;idx</span>
                            <span><a class="ntdelbutton" id="post_tag-check-num-2">X</a>&nbsp;wordpress</span>
                        </div>
                        <input type="hidden" name="as_contact_tags" value="" />
                    </div>
                    -->
                    <div class="agentstorm-input">
                        <input name="as_contact_save" class="button-secondary" value="Save Changes" type="submit" />
                    </div>
                </form>
            </div>
            <div id="tabs-3" class="ui-tabs-hide">
                <div class="ui-state-highlight ui-corners-msgbox" style="margin-top: 10px; padding: 0 .7em;"> 
                    <p>
                        <span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span><strong>Information</strong><br />
                        Configure how IDX data is displayed on your web site. Property Listings can use SEO URL's to give your site a boost in Domain Authority and
                        the number of indexed pages.
                    </p>
                </div>
                <form action="" method="POST">
                    <div class="agentstorm-input">
                        <label>Use SEO URL's:</label><br />
                        <span class="small">Use SEO URL's that aid in search engine indexing and appearing in search results.</span><br />
                        <input type="checkbox" name="as_idx_seo" class="text" value="1" <?php if (get_option('as_idx_seo') == true): ?>checked="checked"<?php endif; ?> />
                    </div>
                    <div class="agentstorm-input">
                        <label>Property URL Prefix:</label><br />
                        <span class="small">A prefix defines what virtual sub directory holds properties. for example, 'property' set here will make your IDX listings be located at <?php echo bloginfo('url'); ?>/property/</span><br />
                        <input type="text" name="as_idx_urlprefix" class="text" value="<?php echo (get_option('as_idx_urlprefix')) ? get_option('as_idx_urlprefix') : 'property'; ?>" />
                    </div>
                    <div class="agentstorm-input">
                        <label>Show School Information:</label><br />
                        <span class="small">Show the School District, Elementary School, Middle School and High School as provided by the MLS.</span><br />
                        <input type="checkbox" name="as_idx_schools" class="text" value="1" <?php if (get_option('as_idx_schools') == true): ?>checked="checked"<?php endif; ?> />
                    </div>
                    <div class="agentstorm-input">
                        <label>Show Google Map:</label><br />
                        <span class="small">Show a Google map on the property result screen.</span><br />
                        <input type="checkbox" name="as_idx_gmap" class="text" value="1" <?php if (get_option('as_idx_gmap') == true): ?>checked="checked"<?php endif; ?> />
                    </div>
                    <div class="agentstorm-input">
                        <label>Show Bing Birds Eye View:</label><br />
                        <span class="small">Show a Bing Bird Eye on the property result screen.</span><br />
                        <input type="checkbox" name="as_idx_bview" class="text" value="1" <?php if (get_option('as_idx_bview') == true): ?>checked="checked"<?php endif; ?> />
                    </div>
                    <div class="agentstorm-input">
                        <label>Walkscore API Key:</label><br />
                        <span class="small">Enter your <a href="http://www.walkscore.com/request-api-key.php">Walkscore API Key</a> to display a Walkscore on your listing pages.</span><br />
                        <input type="text" name="as_idx_walkscore" class="text" value="<?php echo get_option('as_idx_walkscore'); ?>" />
                    </div>
                    <div class="agentstorm-input">
                        <label>Search Page Prefix Text:</label><br />
                        <span class="small">Shows text before the property search page</span><br />
                        <textarea name="as_idx_searchtxt" style="width: 98%;"><?php echo get_option('as_idx_searchtxt'); ?></textarea>
                    </div>
                    <div class="agentstorm-input">
                        <input name="as_idx_save" class="button-secondary" value="Save Changes" type="submit" />
                    </div>
                </form>
            </div>
            <div id="tabs-4" class="ui-tabs-hide">
                <div class="ui-state-highlight ui-corners-msgbox" style="margin-top: 10px; padding: 0 .7em;"> 
                    <p>
                        <span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span><strong>Information</strong><br />
                        Configure what IDX data is displayed on your web site. Choose to display all properties in your Agent Storm account or a subset of data using Tags.
                    </p>
                </div>
                <form action="" method="POST">
                    <div class="agentstorm-input">
                        <label>Searchable Property Classes:</label><br />
                        <span class="small">Define which property classes can be searched from your site.<br />
                        <input type="checkbox" name="as_idx_settings_classes_res" value="1" <?php if (get_option('as_idx_settings_classes_res', false)): ?>checked="checked"<?php endif; ?> /> Residential<br />
                        <input type="checkbox" name="as_idx_settings_classes_com" value="1" <?php if (get_option('as_idx_settings_classes_com', false)): ?>checked="checked"<?php endif; ?> /> Commercial<br />
                        <input type="checkbox" name="as_idx_settings_classes_lnd" value="1" <?php if (get_option('as_idx_settings_classes_lnd', false)): ?>checked="checked"<?php endif; ?> /> Land<br />
                        <input type="checkbox" name="as_idx_settings_classes_mob" value="1" <?php if (get_option('as_idx_settings_classes_mob', false)): ?>checked="checked"<?php endif; ?> /> Mobile<br />
                        <input type="checkbox" name="as_idx_settings_classes_mfh" value="1" <?php if (get_option('as_idx_settings_classes_mfh', false)): ?>checked="checked"<?php endif; ?> /> Multi Family Home<br />
                        <input type="checkbox" name="as_idx_settings_classes_rnt" value="1" <?php if (get_option('as_idx_settings_classes_rnt', false)): ?>checked="checked"<?php endif; ?> /> Rental<br />
                    </div>
                    <div class="agentstorm-input">
                        <label>Results Per Page:</label><br />
                        <span class="small">Sets how many property results are displayed per page.<br />
                        <select name="as_idx_settings_pagelimit">
                            <option value="10" <?php if (get_option('as_idx_settings_pagelimit') == '10'): ?>selected="selected"<?php endif; ?>>10</option>
                            <option value="25" <?php if (get_option('as_idx_settings_pagelimit') == '25'): ?>selected="selected"<?php endif; ?>>25</option>
                            <option value="50" <?php if (get_option('as_idx_settings_pagelimit') == '50'): ?>selected="selected"<?php endif; ?>>50</option>
                            <option value="100" <?php if (get_option('as_idx_settings_pagelimit') == '100'): ?>selected="selected"<?php endif; ?>>100</option>
                        </select>
                    </div>
                    <div class="agentstorm-input">
                        <label>Show only Properties assigned the following Tag:</label><br />
                        <span class="small">Shows only properties which have been assigned the following tag during import</span><br />
                        <select name="as_idx_settings_tag">
                            <option value="">All</option>
                            <?php foreach(get_option('as_tags') as $tag): ?>
                                <option value="<?php echo $tag->Name; ?>" <?php if (get_option('as_idx_settings_tag') == $tag->Name): ?>selected="selected"<?php endif; ?>><?php echo strtoupper($tag->Name); ?></option>
                            <?php endforeach; ?>
                        </select>
                    </div>
                    <div class="agentstorm-input">
                        <input name="as_idx_settings_save" class="button-secondary" value="Save Changes" type="submit" />
                    </div>
                </form>
            </div>
            <div id="tabs-5" class="ui-tabs-hide">
                <div class="ui-state-highlight ui-corners-msgbox" style="margin-top: 10px; padding: 0 .7em;"> 
                    <p>
                        <span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span><strong>Information</strong><br />
                        The information below will be placed on every listing as a point of contact. Note: The listing agent will still be shown in the Broker Reciprocity section.
                    </p>
                </div>
                <form action="" method="POST">
                    <div class="agentstorm-input">
                        <label>Agent Name</label><br />
                        <span class="small">The name of the REALTOR who owns this web site.</span><br />
                        <input type="text" class="text" name="as_idx_agent_name" value="<?php echo get_option('as_idx_agent_name', ''); ?>" />
                    </div>
                    <div class="agentstorm-input">
                        <label>Agent Telephone</label><br />
                        <span class="small">The contact telephone number of the REALTOR who owns this web site.</span><br />
                        <input type="text" class="text" name="as_idx_agent_phone" value="<?php echo get_option('as_idx_agent_phone', ''); ?>" />
                    </div>
                    <div class="agentstorm-input">
                        <label>Agent Email</label><br />
                        <span class="small">The contact email address of the REALTOR who owns this web site.</span><br />
                        <input type="text" class="text" name="as_idx_agent_email" value="<?php echo get_option('as_idx_agent_email', ''); ?>" />
                    </div>
                    <div class="agentstorm-input">
                        <label>Agent Additional Info</label><br />
                        <span class="small">Additional information to include in the Contact Box such as State License Numbers etc</span><br />
                        <textarea name="as_idx_agent_extra" class="text" /><?php echo get_option('as_idx_agent_extra', ''); ?></textarea>	
                    </div>
                    <div class="agentstorm-input">
                        <input name="as_idx_agent_save" class="button-secondary" value="Save Changes" type="submit" />
                    </div>
                </form>
            </div>
            <div id="tabs-6" style="overflow:hidden; position:relative; padding: 0; padding-left:210px;">
                <div style="width:200px; height:550px; float:left; top:0; left:0; position:absolute;">
                    <div id="metadata-accordion">
                        <?php foreach (get_option('as_metadata') as $metadata): ?>
                            <h3 original-title="<?php echo $metadata->id; ?>"><a href="#"><?php echo $metadata->name; ?></a></h3>
                            <div style="background-color:#EEE;">
                                <h5>Available Fields</h5>
                                <ul id="sortable_<?php echo $metadata->id; ?>" class="sortable connectedSortable_<?php echo $metadata->id; ?>">
                                    <?php foreach ($metadata->Fields as $field): ?>
                                        <li id="<?php echo $metadata->id; ?>_<?php echo $field->Name; ?>" class="ui-state-default ui-priority-secondary"><span class="ui-icon ui-icon-arrowthick-2-n-s"></span><?php echo $field->Name; ?></li>
                                    <?php endforeach; ?>
                                </ul>
                            </div>
                        <?php endforeach; ?>
                    </div>
                </div>
                <div style="width:100%; height:550px; float:left; overflow-x: hidden; overflow-y: auto;">
                    <?php $first = true; ?>
                    <?php foreach (get_option('as_metadata') as $metadata): ?>
                        <div id="editor_<?php echo $metadata->id; ?>" <?php if (!$first): ?>style="display: none;"<?php endif; ?>>
                            <h3><?php echo $metadata->name; ?></h3>
                            <h5>Result Header</h5>
                            <div>
                                <ul id="sortable_<?php echo $metadata->id; ?>_header" class="sortable connectedSortable_<?php echo $metadata->id; ?>">
                                </ul>
                            </div>
                            <h5>Features</h5>
                            <div>
                                <ul id="sortable_<?php echo $metadata->id; ?>_features" class="sortable connectedSortable_<?php echo $metadata->id; ?>">
                                </ul>
                            </div>
                        </div>
                        <?php $first = false; ?>
                    <?php endforeach; ?>
                </div>
            </div>
        </div>
    </div>
    
</div>

<style type="text/css">
H3 { margin: 0; margin: 0.5em 0; }
H5 { margin: 0; margin: 0.5em 5px 0 5px; }
.ui-accordion .ui-accordion-content { padding: 0 !important;}
.sortable li { position:relative; margin: 0 0 2px 0; padding: 0.2em; padding-left: 1.5em; font-size: 12px; height: 18px; cursor:pointer; }
.sortable li span { position: absolute; margin-left: -1.3em; }
.sortable { background: #eee; padding: 5px; }
</style>

<script type="text/javascript">
	jQuery(document).ready(function($) {
        
        function setupAccordion(event, ui) {
            jQuery("#metadata-accordion").removeClass('ui-corner-all');
            jQuery("#metadata-accordion H3").removeClass('ui-corner-top');
            jQuery("#metadata-accordion H3").removeClass('ui-corner-all');
            jQuery("#metadata-accordion DIV").removeClass('ui-corner-bottom');
            if (ui) {
                jQuery("#editor_" + ui.newHeader.attr("original-title")).show();
                jQuery("#editor_" + ui.oldHeader.attr("original-title")).hide();
            }
        }
        
        function setupAccordionEnd() {
            if (jQuery("#metadata-accordion > :last").is(':visible')) {
                jQuery("#metadata-accordion > :last").prev().removeClass('ui-corner-bl');
                jQuery("#metadata-accordion > :last").addClass('ui-corner-bl');
            } else {
                jQuery("#metadata-accordion > :last").prev().addClass('ui-corner-bl');
                jQuery("#metadata-accordion > :last").removeClass('ui-corner-bl');
            }
        }
        
        jQuery("#metadata-accordion").accordion({ fillSpace: true });
        jQuery("#metadata-accordion").bind('accordionchangestart', setupAccordion);
        jQuery("#metadata-accordion").bind('accordionchange', setupAccordionEnd);
        setupAccordion();
        setupAccordionEnd();
		jQuery("#agentstorm-tabs").tabs();
        jQuery("#agentstorm-tabs UL").removeClass('ui-corner-all').addClass('ui-corner-top');
        jQuery("#metadata-accordion").accordion({ fillSpace: true });
        
        function serialize(prefix, target, obj) {
            pr = prefix;
            result = {};
            result['action'] = 'agentstorm_result_layout';
            result['target'] = target;
            result[pr + '[]'] = Array();
            jQuery.each(obj.children(), function(index, element) {
                result[pr + '[]'].push(element.id.replace(pr + '_', ''));
            });
            return result;
        }
        
        <?php foreach(get_option('as_metadata') as $metadata): ?>
		jQuery("#sortable_<?php echo $metadata->id; ?>, #sortable_<?php echo $metadata->id; ?>_header, #sortable_<?php echo $metadata->id; ?>_features").sortable({
			connectWith: '.connectedSortable_<?php echo $metadata->id; ?>',
            appendTo: 'body',
            helper: 'clone',
            placeholder: 'ui-state-highlight',
            stop: function(event, ui) {
                $.post(ajaxurl, serialize('<?php echo $metadata->id; ?>', 'header', $('#sortable_<?php echo $metadata->id; ?>_header')));
                $.post(ajaxurl, serialize('<?php echo $metadata->id; ?>', 'features', $('#sortable_<?php echo $metadata->id; ?>_features')));
            }
		}).disableSelection();
        <?php endforeach; ?>
        
        <?php foreach(get_option('as_metadata') as $metadata): ?>
            <?php foreach (explode(',', get_option('as_metadata_' . $metadata->id . '_header')) as $item): ?>
                <?php if (!empty($item)): ?>
		jQuery("#sortable_<?php echo $metadata->id; ?>_header").append(jQuery("#<?php echo $metadata->id; ?>_<?php echo $item; ?>"));
                <?php endif; ?>
            <?php endforeach; ?>
            <?php foreach (explode(',', get_option('as_metadata_' . $metadata->id . '_features')) as $item): ?>
                <?php if (!empty($item)): ?>
		jQuery("#sortable_<?php echo $metadata->id; ?>_features").append(jQuery("#<?php echo $metadata->id; ?>_<?php echo $item; ?>"));
                <?php endif; ?>
            <?php endforeach; ?>
        <?php endforeach; ?>
        
	});
</script>

